Codeforces Round #431 (Div. 2)

A. Odds and Ends

Where do odds begin, and where do they end? Where does hope emerge, and will they ever break?

Given an integer sequence a1, a2, ..., an of length n. Decide whether it is possible to divide it into an odd number of non-empty subsegments, the each of which has an odd length and begins and ends with odd numbers.

A subsegment is a contiguous slice of the whole sequence. For example, {3, 4, 5} and {1} are subsegments of sequence {1, 2, 3, 4, 5, 6}, while {1, 2, 4} and {7} are not.

Input

The first line of input contains a non-negative integer n (1 ≤ n ≤ 100) — the length of the sequence.

The second line contains n space-separated non-negative integers a1, a2, ..., an (0 ≤ ai ≤ 100) — the elements of the sequence.

Output

Output "Yes" if it‘s possible to fulfill the requirements, and "No" otherwise.

You can output each letter in any case (upper or lower).

Examples

input

31 3 5

output

Yes

input

51 0 1 5 1

output

Yes

input

34 3 1

output

No

input

43 9 9 3

output

No

Note

In the first example, divide the sequence into 1 subsegment: {1, 3, 5} and the requirements will be met.

In the second example, divide the sequence into 3 subsegments: {1, 0, 1}, {5}, {1}.

In the third example, one of the subsegments must start with 4 which is an even number, thus the requirements cannot be met.

In the fourth example, the sequence can be divided into 2 subsegments: {3, 9, 9}, {3}, but this is not a valid solution because 2 is an even number.

题意:给定一数组,判断是否可以分成奇数个组,每组个数是奇数,每组的首尾都为奇数。

分析:偶数长度不可能,奇数长度无论怎么分,首尾必须都为奇数,否则不可能,思维题!

#include <bits/stdc++.h>

using namespace std;

const int maxn = 105;

int a[maxn];

int main()
{
    int n;
    scanf("%d",&n);

    for(int i = 0; i < n; i++)
        scanf("%d",&a[i]);

    if(n%2==1) {
        if(a[0]%2==0||a[n-1]%2==0)
            puts("No");
        else puts("Yes");
    }
    else {
        puts("No");
    }

    return 0;
}

B. Tell Your World

Connect the countless points with lines, till we reach the faraway yonder.

There are n points on a coordinate plane, the i-th of which being (i, yi).

Determine whether it‘s possible to draw two parallel and non-overlapping lines, such that every point in the set lies on exactly one of them, and each of them passes through at least one point in the set.

Input

The first line of input contains a positive integer n (3 ≤ n ≤ 1 000) — the number of points.

The second line contains n space-separated integers y1, y2, ..., yn ( - 109 ≤ yi ≤ 109) — the vertical coordinates of each point.

Output

Output "Yes" (without quotes) if it‘s possible to fulfill the requirements, and "No" otherwise.

You can print each letter in any case (upper or lower).

Examples

input

57 5 8 6 9

output

Yes

input

5-1 -2 0 0 -5

output

No

input

55 4 3 2 1

output

No

input

51000000000 0 0 0 0

output

Yes

Note

In the first example, there are five points: (1, 7), (2, 5), (3, 8), (4, 6) and (5, 9). It‘s possible to draw a line that passes through points 1, 3, 5, and another one that passes through points 2, 4 and is parallel to the first one.

In the second example, while it‘s possible to draw two lines that cover all points, they cannot be made parallel.

In the third example, it‘s impossible to satisfy both requirements at the same time.

题意:

给定 n 个点的坐标,判断是否所有的点,都在两条不重合的平行线上。

分析:

计算几何很少接触,但是一般CF的计算几何都是考思维,感觉很复杂,情况很多!

看了大牛的思路,确实厉害。

因为只存在两条平行直线,枚举这平行直线,平行直线可以通过ab,bc,ac,另一个点就在另一条平行的直线上。

这样将所有点分为了两个部分,其中另一个部分,要么只有一个点,要么在一条直线上,并且平行。

#include <bits/stdc++.h>

using namespace std;

const int maxn = 1005;

typedef long long ll;
int n;

struct Node {
    ll x,y;
} nodes[maxn],pp[maxn];

ll cc(Node a,Node b,Node c) {
    return (b.y-a.y)*(c.x-b.x) - (c.y-b.y)*(b.x-a.x);
}

bool check() {
    int cnt=0;
    for(int i=3; i<=n; i++)
        if(cc(nodes[1],nodes[2],nodes[i])!=0)
            pp[++cnt]=nodes[i];

    for(int i=3; i<=cnt; i++)
        if(cc(pp[1],pp[2],pp[i])!=0)
            return 0;
    Node ta,tb,tc;
    ta.x=nodes[2].x-nodes[1].x,ta.y=nodes[2].y-nodes[1].y;
    tb.x=pp[2].x-pp[1].x,tb.y=pp[2].y-pp[1].y;
    tc.x=tc.y=0;
    return cnt<2||cc(tc,ta,tb)==0;
}

int main() {
    scanf("%d",&n);

    for(int i = 1; i <= n; i++) {
        scanf("%I64d",&nodes[i].y);
        nodes[i].x = i;
    }

    int ff = 0;
    for(int i=3; i<=n&&!ff; i++)
        if(cc(nodes[i-2],nodes[i-1],nodes[i])!=0)
            ff=1;
    if(!ff) {
        printf("NO\n");
        return 0;
    }
    if(check()) {
        printf("YES\n");
        return 0;
    }
    swap(nodes[1],nodes[3]);
    if(check()) {
        printf("YES\n");
        return 0;
    }
    swap(nodes[2],nodes[3]);
    if(check()) {
        printf("YES\n");
        return 0;
    }
    printf("NO\n");
    return 0;

    return 0;
}

C. From Y to Y

From beginning till end, this message has been waiting to be conveyed.

For a given unordered multiset of n lowercase English letters ("multi" means that a letter may appear more than once), we treat all letters as strings of length 1, and repeat the following operation n - 1 times:

  • Remove any two elements s and t from the set, and add their concatenation s + t to the set.

The cost of such operation is defined to be , where f(s, c) denotes the number of times character cappears in string s.

Given a non-negative integer k, construct any valid non-empty set of no more than 100 000 letters, such that the minimum accumulative cost of the whole process is exactly k. It can be shown that a solution always exists.

Input

The first and only line of input contains a non-negative integer k (0 ≤ k ≤ 100 000) — the required minimum cost.

Output

Output a non-empty string of no more than 100 000 lowercase English letters — any multiset satisfying the requirements, concatenated to be a string.

Note that the printed string doesn‘t need to be the final concatenated string. It only needs to represent an unordered multiset of letters.

Examples

input

12

output

abababab

input

3

output

codeforces

Note

For the multiset {‘a‘, ‘b‘, ‘a‘, ‘b‘, ‘a‘, ‘b‘, ‘a‘, ‘b‘}, one of the ways to complete the process is as follows:

  • {"ab", "a", "b", "a", "b", "a", "b"}, with a cost of 0;
  • {"aba", "b", "a", "b", "a", "b"}, with a cost of 1;
  • {"abab", "a", "b", "a", "b"}, with a cost of 1;
  • {"abab", "ab", "a", "b"}, with a cost of 0;
  • {"abab", "aba", "b"}, with a cost of 1;
  • {"abab", "abab"}, with a cost of 1;
  • {"abababab"}, with a cost of 8.

The total cost is 12, and it can be proved to be the minimum cost of the process.

题意:给定一个整数 k ,求构造一个字符串,字符串由单个多重集合的字母拼起来,每次连接两个字符串,都有代价,总代价题目中有。

分析:

策略是:全部都与单字符拼起来。接近答案时,换一个字符重头来。

#include <bits/stdc++.h>

using namespace std;

int main()
{

    int n;
    scanf("%d",&n);

    string s = "";
    if(n==0) {
        cout<<"a"<<endl;
    }
    else {
        char c = ‘a‘;
        while(n) {
            int sum = 0;
            int i = 0;
            for(i = 0; sum <=n; i++) {
                sum +=i;
            }

            n -=(sum-i+1);
            for(int j = 0; j<i-1;j++) {
                s +=c;
            }
            c++;

        }
        cout<<s<<endl;
    }

    return 0;
}

总的来说,感觉思维上和大佬们还是有很大的差距,要继续努力才行~~~

时间: 2024-12-28 16:29:18

Codeforces Round #431 (Div. 2)的相关文章

【推导】【分类讨论】Codeforces Round #431 (Div. 1) B. Rooter&#39;s Song

给你一个这样的图,那些点是舞者,他们每个人会在原地待ti时间之后,以每秒1m的速度向前移动,到边界以后停止.只不过有时候会碰撞,碰撞之后的转向是这样哒: 让你输出每个人的停止位置坐标. ①将x轴上初始坐标记为(pi,0),y轴上的初始坐标记为(0,pi).只有pi-ti相同的才有可能发生碰撞.于是可以按照这一点将人划分为很多组,不同组之间绝对不会互相影响. ②假设一组内每个人都不会发生碰撞,那么所有的路线交叉点都是碰撞点.所以碰撞次数可能达到n^2次,暴力不可行. ③对于一组内,形成了一个网格图

Codeforces Round #431 (Div. 2) C

From beginning till end, this message has been waiting to be conveyed. For a given unordered multiset of n lowercase English letters ("multi" means that a letter may appear more than once), we treat all letters as strings of length 1, and repeat

Codeforces Round #431 (Div. 2) B

Connect the countless points with lines, till we reach the faraway yonder. There are n points on a coordinate plane, the i-th of which being (i, yi). Determine whether it's possible to draw two parallel and non-overlapping lines, such that every poin

Codeforces Round #431 (Div. 2) A

Where do odds begin, and where do they end? Where does hope emerge, and will they ever break? Given an integer sequence a1, a2, ..., an of length n. Decide whether it is possible to divide it into an odd number of non-empty subsegments, the each of w

【推导】【贪心】Codeforces Round #431 (Div. 1) A. From Y to Y

题意:让你构造一个只包含小写字母的可重集,每次可以取两个元素,将它们合并,合并的代价是这两个元素各自的从'a'到'z'出现的次数之积的和. 给你K,你构造的可重集必须满足将所有元素合而为一以后,所消耗的最小代价恰好为K. 考虑只包含一种类字母的消耗代价,以a为例: a 0 aa 1 aaa 3 aaa 6 aaaa 10 aaaaa 15 ... ... 而且如果再其上任意叠加别的字母的话,是互不干涉的.于是可以贪心地从K中依次减去最大的一个上表中的数,输出那么多'a',然后下一次换成'b',如

Codeforces Round #431 Div. 1

A:显然每种字符的代价互不相关,dp并打表可得合并i个字符的最小代价是i*(i-1)/2.然后直接贪心分配每个字符即可.因为每次分配都将剩余代价降到了根号级别所以字符数量是足够的. #include<iostream> #include<cstdio> #include<cmath> #include<cstdlib> #include<cstring> #include<algorithm> using namespace std;

Codeforces Round #247 (Div. 2) ABC

Codeforces Round #247 (Div. 2) http://codeforces.com/contest/431 代码均已投放:https://github.com/illuz/WayToACM/tree/master/CodeForces/431 A - Black Square 题目地址 题意: Jury玩别踩白块,游戏中有四个区域,Jury点每个区域要消耗ai的卡路里,给出踩白块的序列,问要消耗多少卡路里. 分析: 模拟水题.. 代码: /* * Author: illuz

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿